cf Educational Codeforces Round 53 C. Vasya and Robot

2024-03-24 07:48

本文主要是介绍cf Educational Codeforces Round 53 C. Vasya and Robot,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
C. Vasya and Robot
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Vasya has got a robot which is situated on an infinite Cartesian plane, initially in the cell (0,0). Robot can perform the following four kinds of operations:

U — move from (x,y) to (x,y+1);
D — move from (x,y) to (x,y−1);
L — move from (x,y) to (x−1,y);
R — move from (x,y) to (x+1,y).
Vasya also has got a sequence of n operations. Vasya wants to modify this sequence so after performing it the robot will end up in (x,y).

Vasya wants to change the sequence so the length of changed subsegment is minimum possible. This length can be calculated as follows: maxID−minID+1, where maxID is the maximum index of a changed operation, and minID is the minimum index of a changed operation. For example, if Vasya changes RRRRRRR to RLRRLRL, then the operations with indices 2, 5 and 7 are changed, so the length of changed subsegment is 7−2+1=6. Another example: if Vasya changes DDDD to DDRD, then the length of changed subsegment is 1.

If there are no changes, then the length of changed subsegment is 0. Changing an operation means replacing it with some operation (possibly the same); Vasya can’t insert new operations into the sequence or remove them.

Help Vasya! Tell him the minimum length of subsegment that he needs to change so that the robot will go from (0,0) to (x,y), or tell him that it’s impossible.

Input
The first line contains one integer number n (1≤n≤2⋅105) — the number of operations.

The second line contains the sequence of operations — a string of n characters. Each character is either U, D, L or R.

The third line contains two integers x,y (−109≤x,y≤109) — the coordinates of the cell where the robot should end its path.

Output
Print one integer — the minimum possible length of subsegment that can be changed so the resulting sequence of operations moves the robot from (0,0) to (x,y). If this change is impossible, print −1.

Examples
input
5
RURUU
-2 3
output
3
input
4
RULR
1 1
output
0
input
3
UUU
100 100
output
-1
Note
In the first example the sequence can be changed to LULUU. So the length of the changed subsegment is 3−1+1=3.

In the second example the given sequence already leads the robot to (x,y), so the length of the changed subsegment is 0.

In the third example the robot can’t end his path in the cell (x,y).

中文:

给你一个一个操作字符串,包含UDLR,分别表示为向上向下向左向右移动,然后给你一个坐标(x,y),让你去修改一段区间的字符串,使得能从原点走到坐标(x,y),输出这个区间的最小长度,如果不能修改输出-1

代码:

#include<bits/stdc++.h>
using namespace std;typedef long long ll;
const int maxn=200001;int x[maxn],y[maxn],n,X,Y;
string s;int main()
{ios::sync_with_stdio(false);while(cin>>n){cin>>s;cin>>X>>Y;if(abs(X)+abs(Y)>n||(abs(X)+abs(Y)-n)%2){cout<<-1<<endl;continue;}memset(x,0,sizeof(x));memset(y,0,sizeof(y));for(int i=1;i<=n;i++){if(s[i-1]=='U'){y[i]=y[i-1]+1;x[i]=x[i-1];}if(s[i-1]=='D'){y[i]=y[i-1]-1;x[i]=x[i-1];}if(s[i-1]=='R'){x[i]=x[i-1]+1;y[i]=y[i-1];}if(s[i-1]=='L'){x[i]=x[i-1]-1;y[i]=y[i-1];}}int ans=n;int L=0,R=n,tx,ty;int m;while(L<=R){m=(L+R)/2;for(int i=1;i<=n-m+1;i++){tx=x[n]-x[i+m-1]+x[i-1];ty=y[n]-y[i+m-1]+y[i-1];if(abs(X-tx)+abs(Y-ty)>m||(m-abs(X-tx)-abs(Y-ty))%2){if(n-m+1==i)L=m+1;}else{R=m-1;ans=min(ans,m);break;}}}cout<<ans<<endl;}return 0;
}

解答:

如果要到达(x,y),那么只需要横向移动x,纵向移动y即可。所以,如果枚举修改的区间,那么要知道非修改部分有多少横向移动和纵向移动的值。使用预处理前缀和x[i]和y[i]来记录前i个字符串当中横向移动了多少,和纵向移动了多少步。
最后,使用二分或者尺取法枚举区间大小,由于修改区间的中的操作可以变成任意操作,所以只要非区间部分的横向,纵向移动步数和区间长度的关系即可。如果非区间部分的操作在横向和纵向分别已经走了tx和ty,那么横向和纵向剩余的步数abs(x-tx)与abs(x-ty)起码要小于等于修改区间的长度才能实现,此外,如果修改区间的长度减去abs(x-tx)与abs(x-ty)是奇数,那么会多余一个操作或者缺一个操作,使得无法达到(x,y),根据这两个条件来对区间进行二分即可。

这篇关于cf Educational Codeforces Round 53 C. Vasya and Robot的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/840924

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

【CF】C. Glass Carving(二分 + 树状数组 + 优先队列 + 数组计数)

这题简直蛋疼死。。。。。 A了一下午 #include<cstdio>#include<queue>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const int maxn = 200005;int h,w,n;int C1[maxn],C2[maxn];int

【CF】E. Anya and Cubes(双向DFS)

根据题意的话每次递归分3种情况 一共最多25个数,时间复杂度为3^25,太大了 我们可以分2次求解第一次求一半的结果,也就是25/2 = 12,记录结果 之后利用剩余的一半求结果 s-结果 = 之前记录过的结果 就可以 时间复杂度降低为 3 ^ (n/2+1) 题目链接:http://codeforces.com/contest/525/problem/E #include<set